ObjectRecognition Class Reference

`#include </build/pcl-qv3n_B/pcl-1.8.1+dfsg1/doc/tutorials/content/sources/iccv2011/include/object_recognition.h>`

## Public Member Functions

| ObjectRecognition (const ObjectRecognitionParameters &params)
void | populateDatabase (const std::vector< std::string > &filenames)
const ObjectModel & | recognizeObject (const PointCloudPtr &query_cloud)
PointCloudPtr | recognizeAndAlignPoints (const PointCloudPtr &query_cloud)
void | constructObjectModel (const PointCloudPtr &points, ObjectModel &output) const
| ObjectRecognition (const ObjectRecognitionParameters &params)
void | populateDatabase (const std::vector< std::string > &filenames)
const ObjectModel & | recognizeObject (const PointCloudPtr &query_cloud)
PointCloudPtr | recognizeAndAlignPoints (const PointCloudPtr &query_cloud)
void | constructObjectModel (const PointCloudPtr &points, ObjectModel &output) const
| ObjectRecognition (const ObjectRecognitionParameters &params)
void | populateDatabase (const std::vector< std::string > &filenames)
const ObjectModel & | recognizeObject (const PointCloudPtr &query_cloud)
PointCloudPtr | recognizeAndAlignPoints (const PointCloudPtr &query_cloud)
void | constructObjectModel (const PointCloudPtr &points, ObjectModel &output) const

## Protected Member Functions

PointCloudPtr | applyFiltersAndSegment (const PointCloudPtr &input, const ObjectRecognitionParameters &params) const
void | estimateFeatures (const PointCloudPtr &points, const ObjectRecognitionParameters &params, SurfaceNormalsPtr &normals_out, PointCloudPtr &keypoints_out, LocalDescriptorsPtr &local_descriptors_out, GlobalDescriptorsPtr &global_descriptor_out) const
PointCloudPtr | alignModelPoints (const ObjectModel &source, const ObjectModel &target, const ObjectRecognitionParameters &params) const
PointCloudPtr | applyFiltersAndSegment (const PointCloudPtr &input, const ObjectRecognitionParameters &params) const
void | estimateFeatures (const PointCloudPtr &points, const ObjectRecognitionParameters &params, SurfaceNormalsPtr &normals_out, PointCloudPtr &keypoints_out, LocalDescriptorsPtr &local_descriptors_out, GlobalDescriptorsPtr &global_descriptor_out) const
PointCloudPtr | alignModelPoints (const ObjectModel &source, const ObjectModel &target, const ObjectRecognitionParameters &params) const
PointCloudPtr | applyFiltersAndSegment (const PointCloudPtr &input, const ObjectRecognitionParameters &params) const
void | estimateFeatures (const PointCloudPtr &points, const ObjectRecognitionParameters &params, SurfaceNormalsPtr &normals_out, PointCloudPtr &keypoints_out, LocalDescriptorsPtr &local_descriptors_out, GlobalDescriptorsPtr &global_descriptor_out) const
PointCloudPtr | alignModelPoints (const ObjectModel &source, const ObjectModel &target, const ObjectRecognitionParameters &params) const

## Protected Attributes

ObjectRecognitionParameters | params_
std::vector< ObjectModel > | models_
GlobalDescriptorsPtr | descriptors_
pcl::KdTreeFLANN< GlobalDescriptorT >::Ptr | kdtree_

## Detailed Description

Definition at line 57 of file object_recognition.h.

## Constructor & Destructor Documentation

## ObjectRecognition() [1/3]

ObjectRecognition::ObjectRecognition | ( | const ObjectRecognitionParameters & | params | ) |

inline

Definition at line 60 of file object_recognition.h.

## ObjectRecognition() [2/3]

ObjectRecognition::ObjectRecognition | ( | const ObjectRecognitionParameters & | params | ) |

inline

Definition at line 60 of file object_recognition.h.

## ObjectRecognition() [3/3]

ObjectRecognition::ObjectRecognition | ( | const ObjectRecognitionParameters & | params | ) |

inline

Definition at line 60 of file object_recognition.h.

## Member Function Documentation

## alignModelPoints() [1/3]

PointCloudPtr ObjectRecognition::alignModelPoints | ( | const ObjectModel & | source,
|  | const ObjectModel & | target,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 133 of file object_recognition.h.

References ObjectRecognitionParameters::icp_max_correspondence_distance, ObjectRecognitionParameters::icp_max_iterations, ObjectRecognitionParameters::icp_outlier_rejection_threshold, ObjectRecognitionParameters::icp_transformation_epsilon, ObjectRecognitionParameters::initial_alignment_max_correspondence_distance, ObjectRecognitionParameters::initial_alignment_min_sample_distance, ObjectRecognitionParameters::initial_alignment_nr_iterations, ObjectModel::keypoints, ObjectModel::local_descriptors, ObjectModel::points, and pcl::transformPointCloud().

## alignModelPoints() [2/3]

PointCloudPtr ObjectRecognition::alignModelPoints | ( | const ObjectModel & | source,
|  | const ObjectModel & | target,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 176 of file object_recognition.h.

References ObjectRecognitionParameters::icp_max_correspondence_distance, ObjectRecognitionParameters::icp_max_iterations, ObjectRecognitionParameters::icp_outlier_rejection_threshold, ObjectRecognitionParameters::icp_transformation_epsilon, ObjectRecognitionParameters::initial_alignment_max_correspondence_distance, ObjectRecognitionParameters::initial_alignment_min_sample_distance, ObjectRecognitionParameters::initial_alignment_nr_iterations, ObjectModel::keypoints, ObjectModel::local_descriptors, ObjectModel::points, and pcl::transformPointCloud().

## alignModelPoints() [3/3]

PointCloudPtr ObjectRecognition::alignModelPoints | ( | const ObjectModel & | source,
|  | const ObjectModel & | target,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 176 of file object_recognition.h.

References ObjectRecognitionParameters::icp_max_correspondence_distance, ObjectRecognitionParameters::icp_max_iterations, ObjectRecognitionParameters::icp_outlier_rejection_threshold, ObjectRecognitionParameters::icp_transformation_epsilon, ObjectRecognitionParameters::initial_alignment_max_correspondence_distance, ObjectRecognitionParameters::initial_alignment_min_sample_distance, ObjectRecognitionParameters::initial_alignment_nr_iterations, ObjectModel::keypoints, ObjectModel::local_descriptors, ObjectModel::points, and pcl::transformPointCloud().

## applyFiltersAndSegment() [1/3]

PointCloudPtr ObjectRecognition::applyFiltersAndSegment | ( | const PointCloudPtr & | input,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 96 of file object_recognition.h.

References ObjectRecognitionParameters::cluster_tolerance, pcl::copyPointCloud(), ObjectRecognitionParameters::downsample_leaf_size, ObjectRecognitionParameters::max_cluster_size, ObjectRecognitionParameters::max_depth, ObjectRecognitionParameters::max_ransac_iterations, ObjectRecognitionParameters::min_cluster_size, ObjectRecognitionParameters::min_depth, ObjectRecognitionParameters::outlier_rejection_min_neighbors, ObjectRecognitionParameters::outlier_rejection_radius, and ObjectRecognitionParameters::plane_inlier_distance_threshold.

## applyFiltersAndSegment() [2/3]

PointCloudPtr ObjectRecognition::applyFiltersAndSegment | ( | const PointCloudPtr & | input,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 139 of file object_recognition.h.

References ObjectRecognitionParameters::cluster_tolerance, pcl::copyPointCloud(), ObjectRecognitionParameters::downsample_leaf_size, ObjectRecognitionParameters::max_cluster_size, ObjectRecognitionParameters::max_depth, ObjectRecognitionParameters::max_ransac_iterations, ObjectRecognitionParameters::min_cluster_size, ObjectRecognitionParameters::min_depth, ObjectRecognitionParameters::outlier_rejection_min_neighbors, ObjectRecognitionParameters::outlier_rejection_radius, and ObjectRecognitionParameters::plane_inlier_distance_threshold.

## applyFiltersAndSegment() [3/3]

PointCloudPtr ObjectRecognition::applyFiltersAndSegment | ( | const PointCloudPtr & | input,
|  | const ObjectRecognitionParameters & | params
| ) |  | const

inline protected

Definition at line 139 of file object_recognition.h.

References ObjectRecognitionParameters::cluster_tolerance, pcl::copyPointCloud(), ObjectRecognitionParameters::downsample_leaf_size, ObjectRecognitionParameters::max_cluster_size, ObjectRecognitionParameters::max_depth, ObjectRecognitionParameters::max_ransac_iterations, ObjectRecognitionParameters::min_cluster_size, ObjectRecognitionParameters::min_depth, ObjectRecognitionParameters::outlier_rejection_min_neighbors, ObjectRecognitionParameters::outlier_rejection_radius, and ObjectRecognitionParameters::plane_inlier_distance_threshold.

## constructObjectModel() [1/3]

void ObjectRecognition::constructObjectModel | ( | const PointCloudPtr & | points,
|  | ObjectModel & | output
| ) |  | const

inline

Definition at line 84 of file object_recognition.h.

References ObjectModel::global_descriptor, ObjectModel::keypoints, ObjectModel::local_descriptors, and ObjectModel::points.

## constructObjectModel() [2/3]

void ObjectRecognition::constructObjectModel | ( | const PointCloudPtr & | points,
|  | ObjectModel & | output
| ) |  | const

inline

Definition at line 127 of file object_recognition.h.

References ObjectModel::global_descriptor, ObjectModel::keypoints, ObjectModel::local_descriptors, and ObjectModel::points.

## constructObjectModel() [3/3]

void ObjectRecognition::constructObjectModel | ( | const PointCloudPtr & | points,
|  | ObjectModel & | output
| ) |  | const

inline

Definition at line 127 of file object_recognition.h.

References ObjectModel::global_descriptor, ObjectModel::keypoints, ObjectModel::local_descriptors, and ObjectModel::points.

## estimateFeatures() [1/3]

void ObjectRecognition::estimateFeatures | ( | const PointCloudPtr & | points,
|  | const ObjectRecognitionParameters & | params,
|  | SurfaceNormalsPtr & | normals_out,
|  | PointCloudPtr & | keypoints_out,
|  | LocalDescriptorsPtr & | local_descriptors_out,
|  | GlobalDescriptorsPtr & | global_descriptor_out
| ) |  | const

inline protected

Definition at line 116 of file object_recognition.h.

References ObjectRecognitionParameters::keypoints_min_contrast, ObjectRecognitionParameters::keypoints_min_scale, ObjectRecognitionParameters::keypoints_nr_octaves, ObjectRecognitionParameters::keypoints_nr_scales_per_octave, ObjectRecognitionParameters::local_descriptor_radius, and ObjectRecognitionParameters::surface_normal_radius.

## estimateFeatures() [2/3]

void ObjectRecognition::estimateFeatures | ( | const PointCloudPtr & | points,
|  | const ObjectRecognitionParameters & | params,
|  | SurfaceNormalsPtr & | normals_out,
|  | PointCloudPtr & | keypoints_out,
|  | LocalDescriptorsPtr & | local_descriptors_out,
|  | GlobalDescriptorsPtr & | global_descriptor_out
| ) |  | const

inline protected

Definition at line 159 of file object_recognition.h.

References ObjectRecognitionParameters::keypoints_min_contrast, ObjectRecognitionParameters::keypoints_min_scale, ObjectRecognitionParameters::keypoints_nr_octaves, ObjectRecognitionParameters::keypoints_nr_scales_per_octave, ObjectRecognitionParameters::local_descriptor_radius, and ObjectRecognitionParameters::surface_normal_radius.

## estimateFeatures() [3/3]

void ObjectRecognition::estimateFeatures | ( | const PointCloudPtr & | points,
|  | const ObjectRecognitionParameters & | params,
|  | SurfaceNormalsPtr & | normals_out,
|  | PointCloudPtr & | keypoints_out,
|  | LocalDescriptorsPtr & | local_descriptors_out,
|  | GlobalDescriptorsPtr & | global_descriptor_out
| ) |  | const

inline protected

Definition at line 159 of file object_recognition.h.

References ObjectRecognitionParameters::keypoints_min_contrast, ObjectRecognitionParameters::keypoints_min_scale, ObjectRecognitionParameters::keypoints_nr_octaves, ObjectRecognitionParameters::keypoints_nr_scales_per_octave, ObjectRecognitionParameters::local_descriptor_radius, and ObjectRecognitionParameters::surface_normal_radius.

## populateDatabase() [1/3]

void ObjectRecognition::populateDatabase | ( | const std::vector< std::string > & | filenames | ) |

inline

Definition at line 64 of file object_recognition.h.

References pcl::io::loadPCDFile().

## populateDatabase() [2/3]

void ObjectRecognition::populateDatabase | ( | const std::vector< std::string > & | filenames | ) |

inline

Definition at line 64 of file object_recognition.h.

References pcl::io::loadPCDFile().

## populateDatabase() [3/3]

void ObjectRecognition::populateDatabase | ( | const std::vector< std::string > & | filenames | ) |

inline

Definition at line 64 of file object_recognition.h.

## recognizeAndAlignPoints() [1/3]

PointCloudPtr ObjectRecognition::recognizeAndAlignPoints | ( | const PointCloudPtr & | query_cloud | ) |

inline

Definition at line 76 of file object_recognition.h.

## recognizeAndAlignPoints() [2/3]

PointCloudPtr ObjectRecognition::recognizeAndAlignPoints | ( | const PointCloudPtr & | query_cloud | ) |

inline

Definition at line 110 of file object_recognition.h.

References ObjectModel::global_descriptor.

## recognizeAndAlignPoints() [3/3]

PointCloudPtr ObjectRecognition::recognizeAndAlignPoints | ( | const PointCloudPtr & | query_cloud | ) |

inline

Definition at line 110 of file object_recognition.h.

References ObjectModel::global_descriptor.

## recognizeObject() [1/3]

const ObjectModel& ObjectRecognition::recognizeObject | ( | const PointCloudPtr & | query_cloud | ) |

inline

Definition at line 69 of file object_recognition.h.

## recognizeObject() [2/3]

const ObjectModel& ObjectRecognition::recognizeObject | ( | const PointCloudPtr & | query_cloud | ) |

inline

Definition at line 95 of file object_recognition.h.

References ObjectModel::global_descriptor.

## recognizeObject() [3/3]

const ObjectModel& ObjectRecognition::recognizeObject | ( | const PointCloudPtr & | query_cloud | ) |

inline

Definition at line 95 of file object_recognition.h.

References ObjectModel::global_descriptor.

## Member Data Documentation

## descriptors_

GlobalDescriptorsPtr ObjectRecognition::descriptors_

protected

Definition at line 198 of file object_recognition.h.

## kdtree_

pcl::KdTreeFLANN< GlobalDescriptorT >::Ptr ObjectRecognition::kdtree_

protected

Definition at line 199 of file object_recognition.h.

## models_

std::vector< ObjectModel > ObjectRecognition::models_

protected

Definition at line 197 of file object_recognition.h.

## params_

ObjectRecognitionParameters ObjectRecognition::params_

protected

Definition at line 196 of file object_recognition.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/doc/tutorials/content/sources/iccv2011/include/object_recognition.h